$!###############################################################################
$!  << STUNNEL_STARTUP_SERVER.COM >>
$!
$!  Edit this command procedure file to run Stunnel in your environment
$!
$!  AUTHOR: Taka Shinagawa, OpenVMS Security 
$!	    (takaaki.shinagawa@hp.com)
$!  DATE: June 2, 2002
$!###############################################################################
$
$! Define a Stunnel command  /* Edit this for your Stunnel command */
$! Telnet
$ stunnel_command = "STUNNEL -d 992 -r localhost:23 -p [-]stunnel.pem -o stunnel_server.log"
$
$!---------------------------------------------------------------------------------------------------
$! Ask if the private-key is encrypted
$question:
$ inquire encrypted "Is the private key (in the PEM file) encrypted? [Y/N]"
$ if encrypted .eqs. "" 
$ then 
$	goto question
$ else
$	if encrypted .eqs. "Y" then goto encrypted
$	if encrypted .eqs. "N" then goto not_encrypted
$	write sys$output "The input was not accepted: Y or N must be entered."
$	goto question	
$ endif
$!
$encrypted: 
$ inquire password "Enter the password to decrypt the key (please use paired double quotes with it)"
$ if password .eqs. ""  
$ then 
$	goto encrypted
$ else
$	goto done
$ endif
$!
$not_encrypted:
$ password = ""
$!
$done:
$
$!-------------------------------------------------------------------------------
$! << Extract port # of the Stunnel daemon >>
$ d_index = f$locate("-d", stunnel_command)
$ port_string_begin = d_index + 3
$ length = 0
$ start_loop:
$	if f$extract(port_string_begin+length,1,stunnel_command) .nes. " "
$	then 
$	   length = length + 1
$	   goto start_loop
$	else
$	   goto end_loop
$	endif
$ end_loop:
$ port = f$extract(port_string_begin,length,stunnel_command)
$ stunnel_proc_name = "stunnel''port'"
$
$!------------------------------------------------------------------------------------------
$! << Check if Stunnel daemon using the port # already exists >>
$ if f$search("SYS$DISK:[]stunnel_proc_info.com") .nes. ""
$ then
$   delete SYS$DISK:[]stunnel_proc_info.txt;*
$ endif
$
$ show system/process="stunnel''port'"/output=SYS$DISK:[]stunnel_proc_info.txt
$ if f$file_attributes("SYS$DISK:[]stunnel_proc_info.txt","EOF") .ne. 0
$ then
$   write sys$output "Stunnel daemon with this port # already exists"
$   write sys$output "Please make sure the port # with -d or shutdown the Stunnel daemon"
$   delete SYS$DISK:[]stunnel_proc_info.txt;*
$   exit
$ endif
$
$ delete SYS$DISK:[]stunnel_proc_info.txt;*
$
$!------------------------------------------------------------------------------------------
$! << Check if SYS$DISK:[]stunnel_detached.com exists >>
$ if f$search("SYS$DISK:[]stunnel_detached.com") .nes. ""
$ then
$   delete SYS$DISK:[]stunnel_detached.com;*
$ endif
$
$ gosub CREATE_RUN_STUNNEL
$ set file SYS$DISK:[]stunnel_detached.com /protection=(s,o:red,g,w)
$
$! << Create a detached process for Stunnel  >>
$ write sys$output "Starting up a Stunnel running at port ''port'"
$ run /detach sys$system:loginout /input=SYS$DISK:[]stunnel_detached.com -
	/process_name='stunnel_proc_name' -
	/output=nl:
$!
$ delete SYS$DISK:[]stunnel_detached.com;*
$
$!------------------------------------------------------------------------------------------
$! << Check if old SYS$DISK:[]stunnel_proc_info.txt still exists. If so, delete it >>
$ if f$search("SYS$DISK:[]stunnel_proc_info.txt") .nes. ""
$ then
$   delete SYS$DISK:[]stunnel_proc_info.txt;*
$ endif
$!
$! << Sleep for 3 seconds before making sure if the detached process was started up properly >>
$ wait 00:00:03
$!
$! << Check if the detached process started properly >> 
$ show system/process="stunnel''port'"/output=SYS$DISK:[]stunnel_proc_info.txt
$ if f$file_attributes("SYS$DISK:[]stunnel_proc_info.txt","EOF") .eq. 0
$ then
$   write sys$output "Stunnel server failed to start up-- check the configuration, etc."
$   delete SYS$DISK:[]stunnel_proc_info.txt;*
$   exit
$ else
$   write sys$output "Stunnel was successfully started up!"
$   delete SYS$DISK:[]stunnel_proc_info.txt;*
$ endif 
$
$ exit
$
$!------------------------------------------------------------------------------------------
$ CREATE_RUN_STUNNEL:
$       open/write run_stunnel_file SYS$DISK:[]stunnel_detached.com
$       write run_stunnel_file "STUNNEL :== $SYS$DISK:[]stunnel.exe"
$!	
$       write run_stunnel_file stunnel_command
$	write run_stunnel_file "''password'"
$       close run_stunnel_file
$       return
